package es.abrozas.tfcj2ee.action;


import java.util.List;
import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

import es.abrozas.tfcj2ee.controller.EntrenamientoController;
import es.abrozas.tfcj2ee.model.Entrenamiento;
import es.abrozas.tfcj2ee.model.Usuario;

 

public class EstadisticasAction extends ActionSupport {

	private static final long serialVersionUID = -4626403398117169618L;
	 
	private Usuario usuario;
    private String mensaje;
    private String estado;
    private String result;
    private List<Entrenamiento> entrenamientos; 
    
      /**
     * Acción que muestra las estadísticas de los entrenamientos de un usuario
     * @return SUCCESS en caso de éxito o ERROR en caso contrario.
     */
    public String verEstadisticas() {   	
    	try {
	    	this.usuario = (Usuario) ActionContext.getContext().getSession().get("usuario");
	       	this.entrenamientos = EntrenamientoController.getListEntrenamientos(usuario);
	       	if (this.entrenamientos != null) {
	   			String aux = "";
	   			String resultado = "[ ";
	   			int i=1;
	   			for (Entrenamiento entrenamiento : this.entrenamientos) {
	   				aux = "[new Date(" + entrenamiento.getAno() + ", " +entrenamiento.getMes() + ", " + entrenamiento.getDia() + "), ";
	   				aux += String.valueOf(entrenamiento.getKilometros())+ ", ";
	   				aux += "'" + entrenamiento.getDescripcion() + "', ";
	   				aux += String.valueOf(((entrenamiento.getSegundosTotales()/60)/entrenamiento.getKilometros())/100) + "]";
	   				if (i<entrenamientos.size()) aux +=",";
	   				i++;
	   				resultado += aux;
	   			}
	   			resultado += " ]";
	   			this.setResult(resultado);
	   			setMensaje("Se han cargado las estadísticas de los entrenamientos");
	   			setEstado("SUCCESS");
	   			return SUCCESS;
	   		}
	    	else return ERROR;
    	} catch (Exception e) {
    		setEstado(ERROR);
    		setMensaje(e.getMessage());
    		return ERROR;
		}   	
    }

	/**
	 * @return obtiene mensaje
	 */
	public String getMensaje() {
		return mensaje;
	}

	/**
	 * @param mensaje el mensaje a establecer
	 */
	public void setMensaje(String mensaje) {
		this.mensaje = mensaje;
	}

	/**
	 * @return obtiene estado
	 */
	public String getEstado() {
		return estado;
	}

	/**
	 * @param estado el estado a establecer
	 */
	public void setEstado(String estado) {
		this.estado = estado;
	}

	/**
	 * @param result el result a establecer
	 */
	public void setResult(String result) {
		this.result = result;
	}

	/**
	 * @return obtiene result
	 */
	public String getResult() {
		return result;
	}	
}
