package es.abrozas.tfcj2ee.action;


import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

import es.abrozas.tfcj2ee.controller.EntrenamientoController;
import es.abrozas.tfcj2ee.controller.GrupoEntrenamientoController;
import es.abrozas.tfcj2ee.controller.UsuarioController;
import es.abrozas.tfcj2ee.model.Actividad;
import es.abrozas.tfcj2ee.model.Entrenamiento;
import es.abrozas.tfcj2ee.model.Usuario;
import es.abrozas.tfcj2ee.model.GrupoEntrenamiento;

 

public class GruposEntrenamientoAction extends ActionSupport {

	private static final long serialVersionUID = 5331144953986152244L;
	private List<Usuario> result;
	private static final String ERROR_INTERNO             = "Error interno. Por favor, int�ntelo otra vez en unos minutos.";
    
	private Usuario usuario;
    private String mensaje;
    private String estado;
    private Entrenamiento planificacion; 
    private List<Entrenamiento> planificaciones; 
    private List<GrupoEntrenamiento> gruposEntrenamiento; 
    private GrupoEntrenamiento grupoEntrenamiento;
    private List<Usuario> atletas;
    
    private String descripcion;
    private String fecha;
    private String[] actTipo;
    private String[] actRepeticiones;
    private String[] actTiempo;
    private String[] actDistancia;
    private String[] actDescripcion;
   
    /**
     * Carga de los grupos de entrenamiento y datos derivados
     * @return SUCCESS o ERROR en caso del éxito de la acción
     */
    public String loadGruposEntrenamiento(){   	
    	try {
	    	this.usuario = (Usuario) ActionContext.getContext().getSession().get("usuario");
	    	/*
	    	 * Caso de que el usuario sea de tipo entrenador cargaremos su grupo de entrenamiento, si tiene y la pagina del deportista
	    	 */
	    	if (this.usuario.getRol()==1) {
	
	        	this.planificaciones = EntrenamientoController.getListEntrenamientos(usuario);
	    		this.grupoEntrenamiento = GrupoEntrenamientoController.getGrupoByUsuario(usuario);
	    		this.setAtletas(GrupoEntrenamientoController.getAtletasByGrupo(this.grupoEntrenamiento));
	    		return SUCCESS;
	    	} 
			/*
	    	 * Caso de que el usuario sea de tipo atleta cargaremos su grupo de entrenamiento, si tiene y la pagina del deportista
	    	 */
	    	else if (this.usuario.getRol()==2) {
	    		this.grupoEntrenamiento = GrupoEntrenamientoController.getGrupoByUsuario(usuario);
	    		if (this.grupoEntrenamiento==null) { 
	    			this.setGruposEntrenamiento(GrupoEntrenamientoController.getGrupos());
	    		} else {
		    		this.setAtletas(GrupoEntrenamientoController.getAtletasByGrupo(this.grupoEntrenamiento));
		    		this.planificaciones = EntrenamientoController.getListEntrenamientos(this.grupoEntrenamiento.getEntrenador());
	    		}
	    		return SUCCESS;
	    	}
	    	else return ERROR;
    	} catch (Exception ex) {
    		this.setMensaje(ex.toString());
    		this.setEstado(ERROR_INTERNO);
    		return ERROR;
    	}
    }
    
    /**
     * Añade un grupo de entrenamiento
     * @return SUCCESS o ERROR en caso del éxito de la acción
     */
    public String grupoEntrenamientoAdd() { 	
    	try {
	    	/* Codificamos nombre y descricpión en UTF8 */
		    String var=((String[]) ActionContext.getContext().getParameters().get("grupoEntrenamiento.nombre"))[0];
		    byte[] arrByte = var.getBytes("ISO-8859-1");
		    grupoEntrenamiento.setNombre(new String(arrByte, "UTF-8"));
	
		    var=((String[]) ActionContext.getContext().getParameters().get("grupoEntrenamiento.descripcion"))[0];
		    arrByte = var.getBytes("ISO-8859-1");
		    grupoEntrenamiento.setDescripcion(new String(arrByte, "UTF-8"));
	    	
		    /* Asignamos el entrenador al grupod e entrenamiento */
		    this.usuario = (Usuario) ActionContext.getContext().getSession().get("usuario");
		    grupoEntrenamiento.setEntrenador(this.usuario);
		    this.usuario.setGrupoEntrenamiento(grupoEntrenamiento);
	    	Usuario userAux = null;
        	if((grupoEntrenamiento = GrupoEntrenamientoController.crearGrupo(grupoEntrenamiento) )!= null) {
            	this.usuario = (Usuario) ActionContext.getContext().getSession().get("usuario");
        		this.usuario.setGrupoEntrenamiento(grupoEntrenamiento);
        		if((userAux = UsuarioController.getUpdatedUser(this.usuario,false))!=null) {
            		this.usuario = userAux;
            		ActionContext.getContext().getSession().put("usuario",this.usuario);
            		System.out.println("success");
            		setMensaje("success");
            		setEstado(SUCCESS);
        		}
        	} else {
        		setMensaje("Grupo de entrenamiento no creado");
                setEstado(ERROR);
        	}
        } catch (Exception e) {
              e.printStackTrace();
              setEstado(ERROR);
              setMensaje(ERROR_INTERNO);
        }
        return SUCCESS;
    }
    
    /**
     * Salva una planificación
     * @return SUCCESS o ERROR en caso del éxito de la acción
     */
    public String savePlanificacion() {
    	try {
	    	List <Actividad> actividades = new ArrayList<Actividad>();
	    	int i = 0;
	    	this.usuario = (Usuario) ActionContext.getContext().getSession().get("usuario");
	    	Entrenamiento planificacion = new Entrenamiento();
	    	planificacion.setUsuario(this.usuario);
	        Map<String, Object> map = ActionContext.getContext().getParameters();
	        String fecha =  ((String[]) map.get("planificacion.fecha"))[0];
	        actTipo = (String[]) map.get("actTipo");
	        actRepeticiones = (String[]) map.get("actRepeticiones");
	        actTiempo = (String[]) map.get("actTiempo");
	        actDistancia = (String[]) map.get("actDistancia");
	        actDescripcion = (String[]) map.get("actDescripcion");
	        planificacion.setFecha(fecha);
	        planificacion.setDescripcion(((String[]) ActionContext.getContext().getParameters().get("planificacion.descripcion"))[0]);
	    	if (actTipo!=null)    		
	        for (String tipo : actTipo)  {
	        	 Actividad act = new Actividad();
	        	 act.setTipo(Integer.valueOf(tipo));
	        	 act.setDistancia(Float.valueOf(actDistancia[i]));
	        	 long tiempo = Long.parseLong(actTiempo[i].split(":")[0])*360000;
	        	 tiempo += Long.parseLong(actTiempo[i].split(":")[1])*6000;
	        	 tiempo += Long.parseLong(actTiempo[i].split(":")[2].replace(".", ""));
	        	 act.setTiempo(tiempo);
	        	 act.setRepeticiones(Integer.valueOf(actRepeticiones[i]));
	        	 act.setEntrenamiento(planificacion);
	        	 act.setDescripcion(actDescripcion[i]);
	        	 actividades.add(act);
		   		 i++;
	         }
	    	 planificacion.setActividades(actividades);
	         EntrenamientoController.saveEntrenamiento(planificacion);
	         setMensaje("Planificacion añadida correctamente");
	    	return SUCCESS;
    	} catch (Exception ex) {
    		this.setMensaje(ex.toString());
    		this.setEstado(ERROR);
    		return ERROR;
    	}
    }
    
    /**
     * Acción que une a un usuario a un grupo de entrenamiento determinado
     * @return SUCCESS o ERROR en caso del éxito de la acción
     */
    public String unirseGrupo() {
    	 String destino = ERROR; 
         Map<String, Object> map = ActionContext.getContext().getParameters();
         try {
         	int id = Integer.valueOf(((String[]) map.get("id"))[0]);
         	GrupoEntrenamiento grupo = GrupoEntrenamientoController.getGrupoById(id);
        	this.usuario = (Usuario) ActionContext.getContext().getSession().get("usuario");
         	this.usuario.setGrupoEntrenamiento(grupo);
         	if (UsuarioController.updateUser(usuario, false)) {
        		setMensaje("Se ha unido correctamente al grupo de entrenamiento");
        		setEstado(SUCCESS);
        		return SUCCESS;
         	}
          } catch (Exception e) {
                 e.printStackTrace();
                 setMensaje(e.getMessage());
                 return ERROR;
           }
           return destino;
    }
    
    /**
     * Acción que elimina a un usuario de un grupo de entrenamiento determinado
     * @return SUCCESS o ERROR en caso del éxito de la acción
     */
    public String abandonarGrupo() {
    	String destino = ERROR;
    	try {
         	GrupoEntrenamiento grupo = null;
        	this.usuario = (Usuario) ActionContext.getContext().getSession().get("usuario");
         	this.usuario.setGrupoEntrenamiento(grupo);
         	if (UsuarioController.updateUser(usuario, false)) {
        		setMensaje("Se ha abandonado correctamente del grupo de entrenamiento");
        		setEstado(SUCCESS);
        		return SUCCESS;
         	}
         	
          } catch (Exception e) {
                 e.printStackTrace();
                 setMensaje(e.getMessage());
                 return ERROR;
           }
           return destino;
    }
    
    /**
     * Acción para mostrar una planificación
     * @return SUCCESS o ERROR en caso del éxito de la acción
     */
    public String verPlanificacion() {
        String destino = ERROR; 
        Map<String, Object> map = ActionContext.getContext().getParameters();
        try {
        	int id = Integer.valueOf(((String[]) map.get("id"))[0]);
        	Entrenamiento planificacion = EntrenamientoController.getEntrenamientoById(id);
        	List actividades = planificacion.getActividades();
        	while (actividades.contains(null)) actividades.remove(null);
        	planificacion.setActividades(actividades);
        	this.planificacion = planificacion;
        	destino = SUCCESS;
         } catch (Exception e) {
                e.printStackTrace();
                setMensaje(e.getMessage());
                return ERROR;
          }
          return destino;
    }
    
    /**
     * Acción que elimina una planificacion determinada
     * @return SUCCESS o ERROR en caso del éxito de la acción
     */
    public String deletePlanificacion() {
    	String destino = ERROR;
        Map<String, Object> map = ActionContext.getContext().getParameters();    	
    	try {
        	int id = Integer.valueOf(((String[]) map.get("id"))[0]);
        	Entrenamiento planificacion = EntrenamientoController.getEntrenamientoById(id);
    		if (EntrenamientoController.deleteEntrenamiento(planificacion)) {
    			destino = SUCCESS;
    			setMensaje("Se ha eliminado la planificación correctamente");
    		}
    	} catch (Exception e) {
            e.printStackTrace();
            setMensaje(e.getMessage());
            return ERROR;    		
    	}
    	return destino;
    }
 
/*
 * Getters & Setters		
 */
    /**
	 * @return the usuario
	 */
    public Usuario getUsuario() {
          return usuario;
    }
    
    /**
	 * @param usuario the usuario to set
	 */
    public void setUsuario(Usuario usuario) {
          this.usuario = usuario;
    }

    /**
	 * @return the result
	 */
	public List<Usuario> getResult() {
		return result;
	}

	/**
	 * @param mensaje the mensaje to set
	 */
	public void setMensaje(String mensaje) {
		this.mensaje = mensaje;
	}

	/**
	 * @return the mensaje
	 */
	public String getMensaje() {
		return mensaje;
	}

	/**
	 * @param descripcion the descripcion to set
	 */
	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	/**
	 * @return the descipcion
	 */
	public String getDescripcion() {
		return descripcion;
	}

	/**
	 * @return the actTiempo
	 */
	public String[] getActTiempo() {
		return actTiempo;
	}

	/**
	 * @param actTiempo the actTiempo to set
	 */
	public void setActTiempo(String[] actTiempo) {
		this.actTiempo = actTiempo;
	}

	/**
	 * @return the actDistancia
	 */
	public String[] getActDistancia() {
		return actDistancia;
	}

	/**
	 * @param actDistancia the actDistancia to set
	 */
	public void setActDistancia(String[] actDistancia) {
		this.actDistancia = actDistancia;
	}

	/**
	 * @return the fecha
	 */
	public String getFecha() {
		return fecha;
	}

	/**
	 * @param fecha the fecha to set
	 */
	public void setFecha(String fecha) {
		this.fecha = fecha;
	}

	/**
	 * @return the actTipo
	 */
	public String[] getActTipo() {
		return actTipo;
	}

	/**
	 * @param actTipo the actTipo to set
	 */
	public void setActTipo(String[] actTipo) {
		this.actTipo = actTipo;
	}

	/**
	 * @return the actRepeticiones
	 */
	public String[] getActRepeticiones() {
		return actRepeticiones;
	}

	/**
	 * @param actRepeticiones the actRepeticiones to set
	 */
	public void setActRepeticiones(String[] actRepeticiones) {
		this.actRepeticiones = actRepeticiones;
	}

	/**
	 * @param actDescripcion the actDescripcion to set
	 */
	public void setActDescripcion(String[] actDescripcion) {
		this.actDescripcion = actDescripcion;
	}

	/**
	 * @return the actDescripcion
	 */
	public String[] getActDescripcion() {
		return actDescripcion;
	}

	/**
	 * @param planificacion the planificacion to set
	 */
	public void setPlanificacion(Entrenamiento planificacion) {
		this.planificacion = planificacion;
	}

	/**
	 * @return the planificacion
	 */
	public Entrenamiento getPlanificacion() {
		return planificacion;
	}

	/**
	 * @param entrenamientos los entrenamientos a establecer
	 */
	public void setPlanificaciones(List<Entrenamiento> planificaciones) {
		this.planificaciones = planificaciones;
	}

	/**
	 * @return los entrenamientos
	 */
	public List<Entrenamiento> getPlanificaciones() {
		return planificaciones;
	}

	/**
	 * @param estado el estado a establecer
	 */
	public void setEstado(String estado) {
		this.estado = estado;
	}

	/**
	 * @return obtiene estado
	 */
	public String getEstado() {
		return estado;
	}

	/**
	 * @return obtiene grupoEntrenamiento
	 */
	public GrupoEntrenamiento getGrupoEntrenamiento() {
		return grupoEntrenamiento;
	}

	/**
	 * @param grupoEntrenamiento el grupoEntrenamiento a establecer
	 */
	public void setGrupoEntrenamiento(GrupoEntrenamiento grupoEntrenamiento) {
		this.grupoEntrenamiento = grupoEntrenamiento;
	}

	/**
	 * @param gruposEntrenamiento el gruposEntrenamiento a establecer
	 */
	public void setGruposEntrenamiento(List<GrupoEntrenamiento> gruposEntrenamiento) {
		this.gruposEntrenamiento = gruposEntrenamiento;
	}

	/**
	 * @return obtiene gruposEntrenamiento
	 */
	public List<GrupoEntrenamiento> getGruposEntrenamiento() {
		return gruposEntrenamiento;
	}

	/**
	 * @param atletas el atletas a establecer
	 */
	public void setAtletas(List<Usuario> atletas) {
		this.atletas = atletas;
	}

	/**
	 * @return obtiene atletas
	 */
	public List<Usuario> getAtletas() {
		return atletas;
	}	
}
