package es.abrozas.tfcj2ee.dao;

import java.util.List;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import es.abrozas.tfcj2ee.model.Actividad;
import es.abrozas.tfcj2ee.model.Entrenamiento;
import es.abrozas.tfcj2ee.utils.HibernateUtil;

public class ActividadDAO {

	/**
	 * Devuelve el listado de actividades en base a un entrenamiento
	 * @return el listado de actividades
	 * @throws Exception cuando hay un error con la recuperación del listado a traves de hibernate
	 */
      public static List<Actividad> getListActividades(Entrenamiento ent) throws Exception {
    	  HibernateUtil.createSessionFactory();
    	  Session session = HibernateUtil.getSession();
    	  Transaction tx = null;
    	  List<Actividad> result = null;
    	  
    	  try {
	          tx = session.beginTransaction();
	          Query hQuery = session.createQuery("from Actividad as e where e.entrenamiento= :entrenamiento_id");
	          hQuery.setLong("entrenamiento_id", ent.getId());
	          result=(List<Actividad>)hQuery.list();
	          session.getTransaction().commit();	          
    	  } catch (RuntimeException e) {
	    	  if(tx != null) tx.rollback();
	    	  throw e;
    	  } finally {
    		  session.close();
    	  }
    	  
    	  return result;          
      }
}
