package es.abrozas.tfcj2ee.model;


import java.io.Serializable;

import es.abrozas.tfcj2ee.model.Entrenamiento;

public class Actividad implements Serializable {
	
	/**
	 * Model de una actividad perteneciente a un entrenamiento o planificación
	 */
	private static final long serialVersionUID = -6983986194674398973L;
	private long id;
	private long tiempo;
	private float distancia;
	private String descripcion;
	private int repeticiones;
	private int tipo;
	private Entrenamiento entrenamiento;


	public Actividad() {
			
	}
		
	/**
	 * @return the id
	 */
	public long getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(long id) {
		this.id = id;
	}

	/**
	 * @return the tiempo
	 */
	public long getTiempo() {
		return tiempo;
	}

	/**
	 * @param tiempo the tiempo to set
	 */
	public void setTiempo(long tiempo) {
		this.tiempo = tiempo;
	}

	/**
	 * @return the distancia
	 */
	public float getDistancia() {
		return distancia;
	}

	/**
	 * @param distancia the distancia to set
	 */
	public void setDistancia(float distancia) {
		this.distancia = distancia;
	}

	/**
	 * @return the descripcion
	 */
	public String getDescripcion() {
		return descripcion;
	}

	/**
	 * @param descripcion the descripci�n to set
	 */
	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	/**
	 * @return the tipo
	 */
	public int getTipo() {
		return tipo;
	}

	/**
	 * @param tipo the tipo to set
	 */
	public void setTipo(int tipo) {
		this.tipo = tipo;
	}

	/**
	 * @param entrenamiento the entrenamiento to set
	 */
	public void setEntrenamiento(Entrenamiento entrenamiento) {
		this.entrenamiento = entrenamiento;
	}

	/**
	 * @return the entrenamiento
	 */
	public Entrenamiento getEntrenamiento() {
		return entrenamiento;
	}

	/**
	 * @param repeticiones the repeticiones to set
	 */
	public void setRepeticiones(int repeticiones) {
		this.repeticiones = repeticiones;
	}

	/**
	 * @return the repeticiones
	 */
	public int getRepeticiones() {
		return repeticiones;
	}

	
	/**
	 * 
	 * @return el tiempo en formato hh:mm:ss.ms
	 */
	public String getFormatearTiempo() {
		long tiempo = this.tiempo;
		int aux = (int) (tiempo%100);
		String ms = String.valueOf(aux);
		tiempo = (long) Math.floor(tiempo/100);
		aux = (int) (tiempo%60);
		String sec = String.valueOf(aux);
		tiempo = (long) Math.floor(tiempo/60);
		aux = (int) (tiempo%60);	
		String min = String.valueOf(aux);
		tiempo = (long) Math.floor(tiempo/60);
		String hor = String.valueOf(tiempo);	
		return ((hor.length()==2)?hor:"0"+hor)+":"+((min.length()==2)?min:"0"+min)+":"+((sec.length()==2)?sec:"0"+sec)+"."+((ms.length()==2)?ms:ms+"0");
	}
}
