package es.abrozas.tfcj2ee.model;

import java.io.Serializable;
import java.sql.Date;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;



public class Usuario implements Serializable{

	private static final long serialVersionUID = -8767337896773261247L;
	
	private Long id;
	private String username;
	private String password;
	private String email;
	private String nombre;
	private String apellidos;
	private String ciudad;
	private Date fechaNacimiento;
	private Integer estado;
	private Integer rol; 
	private GrupoEntrenamiento grupoEntrenamiento;
	private List<Entrenamiento> entrenamientos;
	
	
	public Usuario () {
		this.estado = 1;    	
	}
	
	public Usuario (Long id, String username, String password, Date fechaNacimiento, Integer rol) {
		this.id = id;
		this.username = username;
		this.password = password;
		this.fechaNacimiento = fechaNacimiento;
		this.estado = 1;
		this.rol = rol;
	
	}
	  
	  public Usuario (Long id, String identificador, String contrasenna) {
		  	this.id = id;
		  	this.username      = identificador;
	        this.password  = contrasenna;
	  }
	  
	  public Usuario (String identificador, String contrasenna) {
	  	  this.id = 0l;
	      this.username  = identificador;
	      this.password  = contrasenna;
	
	}
	
	  /**
	   * 
	   * @return la contraseña del usuario
	   */
	  public String getPassword() {	
	        return password;	
	  }
	
	  /**
	   * 
	   * @param contrasenna la contraseña del usuario a establecer 
	   */
	  public void setPassword(String contrasenna) {	
	        this.password = contrasenna;	
	  }
	
	  /**
	   * 
	   * @return el nombre de usuario
	   */
	  public String getUsername() {	
	        return username;	
	  }
	
	  /**
	   * 
	   * @param identificador Establece el nombre de usuario del sistema
	   */
	  public void setUsername(String identificador) {	
	        this.username = identificador;	
	  }
	  
	  /**
	   * 
	   * @param id Establece el identificador único del usuario
	   */
		public void setId(Long id) {
			this.id = id;
		}
		
		/**
		 * 
		 * @return el identificador único del usuario
		 */
		public Long getId() {
			return id;
		}
		
		/**
		 * @param fechanacimiento the fechanacimiento to set
		 */
		public void setFechaNacimiento(Date fechaNacimiento) {
			System.out.println("Fecha nacimient de Date");
			this.fechaNacimiento = fechaNacimiento;
		}
		
		/**
		 * @param fechanacimiento the fechanacimiento to set
		 */
		public void setFechaNacimiento(String fechaNacimiento) {
			System.out.println("Fecha nacimient de string");
			DateFormat sdf = new SimpleDateFormat("MM/dd/yyyy");
			try {
				this.fechaNacimiento = (Date) sdf.parse(fechaNacimiento);            
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		/**
		 * @return the fechanacimiento
		 */
		public Date getFechaNacimiento() {
			return fechaNacimiento;
		}
		
		/**
		 * @param estado the estado to set
		 */
		public void setEstado(Integer estado) {
			this.estado = estado;
		}
		
		/**
		 * @return the estado
		 */
		public Integer getEstado() {
			return estado;
		}
		
		/**
		 * @param rol the rol to set
		 */
		public void setRol(Integer rol) {
			this.rol = rol;
		}
		
		/**
		 * @return the rol
		 */
		public Integer getRol() {
			return rol;
		}
		
		/**
		 * 
		 * @param entrenamientos Establece la lista de entrenamientos del usuario
		 */
		public void setEntrenamientos(List<Entrenamiento> entrenamientos) {
			this.entrenamientos = entrenamientos;
		}
		
		/**
		 * 
		 * @return Devuelve la lista de entrenamientos del usuario
		 */
		public List<Entrenamiento> getEntrenamientos() {
			return entrenamientos;
		}
		
		
		/**
		 * 
		 * @param entrenamiento Añade un entrenamiento a la lista de entrenamientos del usuario
		 */
		public void addEntrenamiento(Entrenamiento entrenamiento) {
			if (this.entrenamientos == null) this.entrenamientos = new ArrayList<Entrenamiento> ();
			this.entrenamientos.add(entrenamiento);
		}
		
		/**
		 * @param email the email to set
		 */
		public void setEmail(String email) {
			this.email = email;
		}
		
		/**
		 * @return the email
		 */
		public String getEmail() {
			return email;
		}
		
		/**
		 * @param nombre the nombre to set
		 */
		public void setNombre(String nombre) {
			this.nombre = nombre;
		}
		
		/**
		 * @return the nombre
		 */
		public String getNombre() {
			return nombre;
		}
		
		/**
		 * @param apellidos the apellidos to set
		 */
		public void setApellidos(String apellidos) {
			this.apellidos = apellidos;
		}
		
		/**
		 * @return the apellidos
		 */
		public String getApellidos() {
			return apellidos;
		}
		
		/**
		 * @param ciudad the ciudad to set
		 */
		public void setCiudad(String ciudad) {
			this.ciudad = ciudad;
		}
		
		/**
		 * @return the ciudad
		 */
		public String getCiudad() {
			return ciudad;
		}
		
		/**
		 * @param grupoEntrenamiento the grupoEntrenamiento to set
		 */
		public void setGrupoEntrenamiento(GrupoEntrenamiento grupoEntrenamiento) {
			this.grupoEntrenamiento = grupoEntrenamiento;
		}
		
		/**
		 * @return the grupoEntrenamiento
		 */
		public GrupoEntrenamiento getGrupoEntrenamiento() {
			return grupoEntrenamiento;
		}

}